#include <string.h>
#include <stdio.h>
#include <avr/io.h>
#include <avr/pgmspace.h> 
#define F_CPU 16000000UL
#include <util/delay.h>

void init(){
	DDRA =0xff;
	DDRC =0xff;
	DDRD &= ~(1<<PD6); //activeaza butonul
}

void anim1(){
	int i;
	PORTC = 0;
	PORTC &= ~(1<<PC7);
	for(i=0; i<8; i++)
	{
		if(i==7)
			PORTC |= (1<<PC7);

		PORTA |= (1<<i);
		_delay_ms(100);
		PORTA = 0x00;
	}

}
void anim2(){
	int i;
	PORTC = 0;
	PORTC = (1<<PC7);
	PORTA = 0xff;
	for(i=0; i<8; i++)
	{
		PORTA ^= (1<<i);
		if(i==7)
		PORTC ^= (1<<PC7);
		_delay_ms(100);
	}
}
void anim3(){
	int j, i;
	PORTC = 0xff;
	PORTA = 0xff;
//	for(j=0;j<5;j++){
		for(i=0;i<3;i++){
			PORTC &= ~(1<<i);
			_delay_ms(100);
		}
		for(i=0;i<3;i++){
			PORTC ^= (1<<i);
			_delay_ms(100);
		}
//	}
	
//	for(j=0;j<5;j++){
		for(i=3;i>=0;i--){
			PORTC &= ~(1<<i);
			_delay_ms(100);
		}
		for(i=3;i>=0;i--){
			PORTC ^= (1<<i);
			_delay_ms(100);
		}

//	}
}
void anim4(){
	int i,j;
	PORTA = 0;
	PORTC |= (1<<PC0) | (1<<PC1) | (1<<PC2);

	PORTC |= (1<<PC7);
	for(i=0;i<3;i++){	
		for(j=0;j<8;j++){
			PORTA |= (1<<j);
			_delay_ms(800);
			if(j%3 ==0){
				PORTC &= ~((1<<PC0) | (1<<PC1) | (1<<PC2));
			}	
		}
		_delay_ms(800);
	}
}	
int main(){
	int k = 0;
	init();
	
	while(1){
		if(bit_is_clear(PIND, PD6)){
			k++;
			k %= 3;
		}
	
		switch(k){
			case 0:
				anim1();
				break;
			case 1:
				anim2();			
				break;
			case 2:
				anim3();
				break;

		}
		_delay_ms(50);

	}	
return 0;
}  	
